1 REM  09-26-12 DM ******************************* ROBOSCOPE prod rel 5.4.
2 REM  Exits back to DOS in line 292
3 REM  ouput routines bypass w/ RETURN @ lines 60/36100
4 REM  For Dob Driver II par port, not compat w/ model 1
5 REM  5.4 added port FCE8, 5.3 changed text to red, added port @ FDC8, adjusts LST from real clk.
6 REM  5.1 changed i/o routine @60-70 to repeat write or read on port for xp problems that do not respond reliably with the TVicNT16 driver.
7 COLOR 12:REM sets high-intensity red text/foreground color.
10 REM *** Local use variables: I N X Y Z
11 REM *** temps ... SY SX CY CX CF SF CQ CP J K P Q X1 Y1
12 REM               N$
13 C%=2:REM- integer command issued to OUT routine
14 REM- Dob command set... Fine Coarse R L U D Mov-Alt Mov-Az
15 F=1:C=2:R=3:L=4:U=5:D=6:MOVAL=8:MOVAZ=9
18 :
19 :
20 REM *** Global variables...
21 A=0:REM - current altitude step pos in steps up from horizon
22 AL=0:REM - Current altitude in degrees
23 ALT=0:REM- Altitude target position in degrees
24 B=0:REM - current az step pos in steps E from N (ccw)
25 AZ=0:REM- Current azimuth in degrees E from N.
26 AZT=0:REM- Azimuth target position in degrees E from N.
27 DE=0:REM- declination in decimal degrees
28 FL1=1:REM- Flag 1, ALT axis readout enable.
29 FL2=1:REM- Flag 2, AZ axis readout enabled.
30 FL3=0:REM- flag 3, alignment achieved
31 FL4=0:REM- tracking in process
32 FL5=0:REM- slew-to request used in catalog handler
33 FL6=0:REM- no file present in catalog read
34 FL7=0:FL8=0:FL9=0:FL10=0:FL11=0:REM FL7,8 not used. fl9=1 if no dob device connected(lines 70-80), fl10=1 if cat info is valid to displ., FL11 is PC save/restore done already (align,exit).
35 GP=0:REM- geographical latitude in decimal degrees
36 PCCLK$="":RUNCLK$="":REM variables to store/restore syst clk, in align&exit.
37 GP1=0:REM- same in radians
38 LSTADJ=0:REM- in 1-sec int routine (7700), maintains sec count for LST ADJUST
39 H=0:REM- decimal hours
41 HA=O:REM- Hour angle
42 FC=C:REM- set fine/coarse code to coarse, c previously defined
43 LS=0:REM- Local Sidereal time
44 RA=0:REM- right ascension in decimal hours
45 M=0:REM- decimal minutes
46 S=0:REM- decimal sec's
47 DIRA=1:REM- set current-alt direction, 1=up 0=dn
48 DIRB=1:REM- set current-az direction, 1=cw 0=ccw
49 :
50 REM *** user calibrated variables...
52 CLS:PRINT"Calibration files found in this Roboscope folder...":PRINT:FILES"*.cal":LL=CSRLIN:LOCATE LL-1,1:PRINT"                      ":LOCATE LL,1
53 PRINT"Type name of scope for cal data (without .CAL). Capitals should not be required.":PRINT:PRINT"If new scope - just type 'new' and at your convenience set up the cal info      required using the main menu... ":PRINT:INPUT"Scope Name: ",SCOPE$
55 N$=SCOPE$:SCOPE$=SCOPE$+".CAL"
56 GOSUB 41500:SCOPE$=N$:REM- read in scope.cal data, n$ w/o .cal for display
57 BMAX=INT(360/DSA):REM- maximum b steps @ 360 deg azimuth
58 GOTO 70:REM- skip over the output routine and search for port addresses.
59 REM *** output command (c%) subroutine - w/5.1 mods for xp
60 IF FL9=1 THEN RETURN         :REM-not connected (see 70)
61 OUT OU,C%                    :REM-send cmd
62 IF INP(IN)>127 THEN 61       :REM-repeat until ack
64 OUT OU,0                     :REM-send punct char
66 IF INP(IN)<128 THEN 64       :REM-repeat until ack
68 RETURN
69 :
70 GOSUB 50000:REM- search for drive response at parallel ports.
71 :
85 REM *** define functions
86 DEF FNS(W)=ATN(W/(SQR(1-W*W)+1D-20))  :REM- returns inverse sin of w,D=dbl pr
87 DEF FNC(W)=1.570796327#-FNS(W)       :REM- returns inverse cos of w, #=dbl pr
88 :
89 KEY OFF:REM **************** MAIN SCREEN / MENU CONTROL ******************
90 GOSUB 900:GOSUB 800:REM- setup main menu screen
205 N$=INKEY$
210 IF N$="1" THEN GOSUB 1000:GOTO 90
220 IF N$="2" THEN GOSUB 46000:GOTO 90
230 IF N$="3" THEN GOSUB 4000:GOTO 90
240 IF N$="4" THEN GOSUB 8000:GOTO 90
290 IF N$="5" THEN CLS:INPUT"Quit program - sure? (y/n)",N$:IF N$="Y" OR N$="y" THEN CLS:TIMER OFF:PRINT"PROGRAM TERMINATED.":GOSUB 49000:SYSTEM:ELSE GOTO 90
291 IF N$<>"" AND FL3=1 THEN GOSUB 48000:REM- must be a direct goto character starting. FL3 is align flg.
293 IF FL5=1 THEN FL5=0:GOSUB 47000:REM if slew-to request see if flying align can be done & do it.
295 IF FL3=1 THEN GOSUB 900:GOSUB 800:GOSUB 7620:GOTO 210:REM  if aligned, set up main menu & route back to track routine, which returns only if n$ selected
300 GOTO 205
799 :
800 PRINT"**** MAIN MENU ****"          :REM-  main menu list
802 PRINT"1. Calibrations."
805 PRINT"2. Two-Star alignment."
810 PRINT"3. Slew to targets."
815 PRINT"4. Manual pan."
820 PRINT"5. Quit."
845 PRINT:PRINT "Enter Selection (or cat# to slew):"
846 IF FL10=1 THEN GOSUB 5800:GOSUB 5900:REM if cat data is valid, display labels & info.
850 RETURN
899 :
900 CLS
901 PRINT"                                                 *******************************"
910 PRINT"                                                     TECH 2000  ROBOSCOPE 5.4"
920 PRINT"                                                     TELESCOPE CONTROL SYSTEM"
950 PRINT"                                                       All rights reserved"
960 PRINT"                                                 *******************************"
965 X=POS(X):Y=CSRLIN:REM  save cursor pos
966 GOSUB 8960:REM displ data
967 LOCATE Y,X
970 RETURN
998 :
999 :
1000 GOSUB 900:PRINT"********** CALIBRATIONS ************
1003 FL10=0:REM disable displ of cat data just in case this cal is in mid-session during use.
1005 PRINT:PRINT"1. Azimuth Encoding."
1007       PRINT"2. Altitude Encoding."
1009       PRINT"3. Azimuth Backlash."
1011       PRINT"4. Altitude Backlash."
1013       PRINT"5. LST Rate Correction"
1014       PRINT"6. Exit/Save."
1015 PRINT:INPUT"Enter Selection: ",N
1017 ON N GOSUB 1030,2000,42000,42500,62600
1018 IF N=5 THEN FL10=1:RETURN:REM- if was LST correction then we re-enable cat display and return immediately since it is already saved in a different file.
1019 IF N=6 THEN INPUT"Save changes to disk? (y/n)",N$:IF N$="y" OR N$="Y" THEN PRINT:INPUT"Enter scope name, ie- Daves18: ",SCOPE$:SCOPE$=SCOPE$+".CAL":PRINT:PRINT"Saving...";SCOPE$:GOSUB 41000
1020 IF N=6 THEN FL10=1:RETURN:REM- re-enable cat data display before exiting.
1021 GOTO 1000
1024 :
1030 GOSUB 900:PRINT"Calibrate Az axis...":REM cls & print header
1035 PRINT:PRINT"Only needs to be done once after scope is built, altered, bearings wear, or     suspected error in initial calibration.  This routine determines the fractional number of degrees moved per step-pulse on the motor drive.
1037 PRINT"Any existing sky alignment will be cleared."
1038 PRINT:PRINT"1. Continue."
1040 PRINT"2. Quit."
1050 PRINT:INPUT"Enter selection...",N
1060 IF N=1 THEN 1100
1070 IF N=2 THEN RETURN
1080 GOTO 1000
1100 GOSUB 900:FL3=0:REM **** AZIMUTH ENCODING CAL ****,  commmitted, init screen, clr aligned flg so bmax chk in pan routine doesn't limit the count.
1110 PRINT"Calibrate Az axis...":PRINT"Tape a pointer on base to indicate when scope has turned 0-360 deg."
1120 PRINT"Push left cusor key until scope backs up (CCW) past pointer.  Then push right   cursor key until pointer is on the mark (CW).  This takes out any backlash in   the motor drive gearing.  Hit F1 when ready."
1130 GOSUB 8010
1140 FOR I=0 TO 1000:NEXT
1150 CLS:PRINT:PRINT"Wait until scope turns ALMOST 360 degrees - then hit F1 when your pointer is    just short of the mark - say 1/8'.  It is a long wait."
1155 DSAP=DSA:REM save dsa previous val. for later.
1160 DSA=0:I=0:KEY(1) ON:ON KEY(1) GOSUB 1900:REM - f1 stop
1169 C%=C:GOSUB 60:C%=R:GOSUB 60: REM- set coarse & right
1170 IF I=1 THEN B=0:PRINT:PRINT"Now use RIGHT cursor key to come up to EXACTLY 360 DEGREES!":PRINT"Hit F1 when done":C%=F:GOSUB 60:FC=F:GOSUB 8030:DSA=360/(DSA+B):N=0:GOTO 1200
1180 C%=MOVAZ:GOSUB 60:DSA=DSA+256:GOTO 1170:REM-  go right until F1 is hit
1199 :
1200 CLS
1210 LOCATE 10,1:PRINT:PRINT"CAL FILE: ";SCOPE$:PRINT"PREV DEGREES/MICROSTEP: ";DSAP:PRINT" NEW DEGREES/MICROSTEP: ";DSA
1220 DEV=DSA-DSAP:PRINT"DEVIATION: ";DEV;:PRINT " (";INT((DEV/DSAP)*10000)/100;"%)"
1230 PRINT:PRINT"Hit any key":N$=INKEY$:IF N$="" THEN 1210 ELSE RETURN
1899 :
1900 I=1:RETURN:REM this subroutine sets f1 flag (I) was hit
1998 :
1999 :
2000 GOSUB 900:PRINT"Calibrate Altitude axis..."
2010 PRINT:PRINT"Only needs to be done once after scope is built, altered, bearings wear, or     suspected error in initial calibration.  This routine determines the fractional number of degrees moved per step-pulse on the motor drive."
2011 PRINT"Any existing sky alignment will be cleared."
2020 PRINT:PRINT"1. Continue."
2030 PRINT"2. Quit."
2040 PRINT:INPUT"Enter selection...",N
2050 IF N=1 THEN 2100
2060 IF N=2 THEN RETURN
2100 GOSUB 900:FL3=0:REM- committed, init screen, clr aligned flg so bmax chk in pan routine doesn't limit the count.
2110 PRINT"Level the scope at the horizon with a level attached firmly."
2120 PRINT"Push DOWN cursor key until scope goes below level.  Then push UP cursor key     until scope is dead level.  This takes out any backlash in the power train.     Hit F1 when ready..."
2130 GOSUB 8010
2140 FOR I=1 TO 1000:NEXT
2150 CLS:PRINT:PRINT"Wait until scope turns ALMOST 90 DEGREES - then hit F1 when your pointer is justshort of vertical."
2155 DSALP=DSAL:REM save dsal prev val for later comparison
2160 DSAL=0:I=0:KEY(1) ON:ON KEY(1) GOSUB 2900:REM - f1 stop
2169 C%=C:GOSUB 60:C%=U:GOSUB 60:REM- set coarse & up
2170 IF I=1 THEN A=0:PRINT:PRINT"Now use UP cursor key to come up to EXACTLY VERTICAL!":PRINT"Hit F1 when done.":C%=F:GOSUB 60: FC=F:GOSUB 8030:DSAL=90/(DSAL+A):N=0:GOTO 2190
2180 C%=MOVAL:GOSUB 60:DSAL=DSAL+256:GOTO 2170:REM- go up til F1 is hit
2190 CLS
2200 LOCATE 10,1:PRINT:PRINT"CAL FILE: ";SCOPE$:PRINT"PREV DEGREES/MICROSTEP: ";DSALP:PRINT" NEW DEGREES/MICROSTEP: ";DSAL
2220 DEV=DSAL-DSALP:PRINT"DEVIATION: ";DEV;:PRINT " (";INT((DEV/DSALP)*10000)/100;"%)"
2230 PRINT:PRINT"Hit any key":N$=INKEY$:IF N$="" THEN 2200 ELSE RETURN
2899 :
2900 I=1:RETURN:REM this subroutine sets F1 (I) was hit.
2998 :
2999 :
3197 :
3198 :
3199 REM ******************************************
3200 REM *** SUBROUTINE - ref star list & get data
3210 CLS
3214 PRINT"ref  Star name   Constellation   Magnitude     Ra    Dec"
3215 PRINT"___  _________   _____________   __________  _h__m  __d__m"
3220 PRINT" 1   Sirius      Canis Major     -1.46(dbl)   6 45  -16 43"
3225 PRINT" 2   Canopus     Carina          -0.72        6 24  -52 42"
3230 PRINT" 3   Rigil Kent  Centaurus       -0.27       14 40  -60 50"
3235 PRINT" 4   Arcturus    Bootes          -0.04       14 16  +19 11"
3240 PRINT" 5   Vega        Lyra            +0.03       18 37  +38 47"
3245 PRINT" 6   Capella     Auriga          +0.08        5 17  +46 00"
3250 PRINT" 7   Rigel       Orion           +0.12        5 15  - 8 12"
3255 PRINT" 8   Procyon     Canis Minor     +0.38        7 39  + 5 14"
3260 PRINT" 9   Archernar   Eridanus        +0.46        1 38  -57 14"
3265 PRINT"10   Betelgeuse  Orion           +0.50(var)   5 55  + 7 24"
3270 PRINT"11   Hadar       Centaurus       +0.61       14 04  -60 22"
3275 PRINT"12   Altair      Aquila          +0.77       19 51  + 8 52"
3280 PRINT"13   Aldebaran   Taurus          +0.85(var)   4 36  +16 31"
3285 PRINT"14   Antares     Scorpius        +0.96(var)  16 29  -26 26"
3290 PRINT"15   Spica       Virgo           +0.98       13 25  -11 10"
3295 PRINT"16   Pollux      Gemini          +1.14        7 45  +28.02"
3300 PRINT"17   Fomalhaut   Piscis Austri.  +1.16       22 58  -29 37"
3305 PRINT"18   Deneb       Cygnus          +1.25       20 41  +45 17"
3310 PRINT"19   Mimosa      Crux            +1.25       12 47  -59 41"
3315 PRINT"20   Regulus     Leo             +1.35       10 08  +11 58"
3320 PRINT"21   Other ref obj - have epoch 2000 coordinates ready"
3330 N=0:INPUT"Select reference star, no selection=main menu: ",N
3350 IF N=0 THEN RETURN:REM no selection (escapes)
3360 FL3=0:REM  clear aligned flg - COMMITED TO RE-ALIGNMENT HERE
3399 :
3400 REM *** process if other ref star selected
3410 IF N=21 THEN Q$="Enter Ra (H,M):":GOSUB 21300:RA=N:Q$="Enter Dec(H,M):":GOSUB 21300:DE=N:GOTO 3600:REM- input ra/dec, conv to plain decimal@21300
3499 :
3500 REM *** else assign the selected ref star coordinates
3510 IF N=1 THEN RA=6.752:DE=-16.72
3515 IF N=2 THEN RA=6.399:DE=-52.7
3520 IF N=3 THEN RA=14.67:DE=-60.83
3525 IF N=4 THEN RA=14.261:DE=19.18
3530 IF N=5 THEN RA=18.616:DE=38.78
3535 IF N=6 THEN RA=5.278:DE=46!
3540 IF N=7 THEN RA=5.242:DE=-8.2
3545 IF N=8 THEN RA=7.655:DE=5.23
3550 IF N=9 THEN RA=1.629:DE=-57.24
3552 IF N=10 THEN RA=5.919:DE=7.41
3554 IF N=11 THEN RA=14.07:DE=-60.37
3556 IF N=12 THEN RA=19.846:DE=8.87
3558 IF N=13 THEN RA=4.599:DE=16.51
3560 IF N=14 THEN RA=16.49:DE=-26.42
3562 IF N=15 THEN RA=13.42:DE=-11.16
3564 IF N=16 THEN RA=7.75:DE=28.03
3566 IF N=17 THEN RA=22.961:DE=-29.62
3568 IF N=18 THEN RA=20.69:DE=45.28
3570 IF N=19 THEN RA=12.78:DE=-59.68
3572 IF N=20 THEN RA=10.139:DE=11.97
3580 IF N>20 THEN GOTO 3200:REM  non-valid entry
3599 :
3600 GOSUB 900:PRINT:PRINT"Using cursor keys, move to reference star then center it."
3610 GOSUB 8020:REM- pan routine
3611 RETURN
3870 :
3998 :
3999 :
4000 GOSUB 900:PRINT"Slew to Coordinate..."
4020 PRINT: PRINT"1. Enter ALT/AZ coordinates & go."
4025 PRINT"2. Enter RA/DEC coordinates & go."
4028 PRINT"3. Use catalogs."
4030 PRINT"4. Exit."
4035 PRINT:INPUT"Enter selection...",N
4037 IF N=4 THEN RETURN
4038 IF N=1 THEN GOTO 4070:REM if altaz continue even if no align (FL3=0)
4039 IF FL3=0 THEN PRINT:BEEP:PRINT"Caution - no alignment.":INPUT"Hit return",N$:IF N=2 THEN 4000
4040 IF N=3 THEN GOSUB 5000:IF FL5=1 THEN RETURN ELSE GOTO 4000:REM- fl5 is slew-to request from catalog ra/de
4042 IF N<>2 THEN 4000
4043 :
4044 REM ****** enter ra/dec coordinates *****
4045 Q$="Enter Ra (H,M):":GOSUB 21300:RA=N
4046 Q$="Enter Dec (D,M):":GOSUB 21300:DE=N:FL5=1:FL10=0:RETURN:REM slew to request, clr cat displ flg.
4047 :
4048 REM- **** SLEW TO RA/DEC *** get time & convert ra/de to altaz target, 4049 is track mode entry point!
4049 GOSUB 22000:REM get time.
4051 GOSUB 35500:ALT=Q:AZT=P:GOTO 4100:REM- 35500converts Ra/De to altaz using LST time.
4069 :
4070 PRINT:INPUT"Enter altitude target degrees...",ALT
4090 INPUT"Enter azimuth target degrees...",AZT
4092 REM  if aligned, calc the new Ra/Dec position to display & slew-request
4094 IF FL3=1 THEN X1=AZT:Y1=ALT:GOSUB 22000:GOSUB 35000:FL5=1:FL10=0:RETURN:REM  set az,al,LS & convert TO RA/DE, set slew-to, clr cat data displ flag.
4096 REM  else if not aligned, continue with alt & azt coordinates
4098 :
4099 REM *** make sure target is in range
4100 IF ALT<0 THEN BEEP:CLS:INPUT"Target below horizon - Hit ret.",N$:GOSUB 22000:Y1=A*DSAL:X1=B*DSA:GOSUB 35000:FL10=0:GOSUB 900:GOSUB 800:RETURN:REM  reset @ present ra/de, clr fl10 object displ, redraw screen elements
4103 IF ALT>90 THEN ALT=90
4104 IF AZT<0 THEN AZT=AZT+360:GOTO 4104
4105 IF AZT>360 THEN AZT=AZT-360:GOTO 4105
4106 :
4120 X=AZT-B*DSA:REM displacement degrees= target-current
4130 IF X<-180 THEN X=X+360:REM figure shortest route, 180 too far ccw
4140 IF X>180 THEN X=X-360:REM  180 too far cw
4141 REM- the next 2 lines avoid the sm directional math errs that happen only on az tracking (uses degrees displacement for the 180 best dir calc, alt does not).  .01 = 36 a-s. Cause x is set to 0, no blash probs should occur anymore.
4142 IF X<0 AND X>-.01 AND DIRB=1 THEN X=0
4143 IF X>0 AND X<.01 AND DIRB=0 THEN X=0
4145 IF X=0 THEN 4210
4150 IF X<0 AND DIRB=1 THEN C%=L:GOSUB 60:GOSUB 36000:REM if chg dir, blash
4155 IF X>0 AND DIRB=0 THEN C%=R:GOSUB 60:GOSUB 36000
4160 X=INT(X/DSA):REM- translate deg to steps - trunc to avoid partial stp
4162 B=INT(B+X):REM- update B +/- x to the new absol integer position
4165 GOSUB 40000:REM- ck B pos, adj if >360 or <0
4170 X=ABS(X):REM  strip sign for mov cmd
4200 REM  ALTITUDE CALC...
4210 Y=INT(ALT/DSAL):REM do ALT, translate target deg to abs pos in steps
4220 Y=Y-A:REM  STEP DISPLACEMENT=TARGET-CURRENT
4222 IF Y<0 AND Y>-8 AND DIRA=1 THEN Y=0:REM if <8 stps in wrong dir, nomove
4223 IF Y>0 AND Y<8 AND DIRA=0 THEN Y=0
4225 IF Y=0 THEN 4310
4230 IF Y<0 AND DIRA=1 THEN C%=D:GOSUB 60:GOSUB 36000:REM set dir , blash
4235 IF Y>0 AND DIRA=0 THEN C%=U:GOSUB 60:GOSUB 36000
4237 A=INT(A+Y):REM- update +/- y to the absolute position
4240 Y=ABS(Y):REM strip sign
4310 IF Y<256 AND X<256 THEN 4360:REM slew to targ, coarse then fine
4320 C%=C:GOSUB 60:REM set coarse
4330 IF Y>255 THEN C%=MOVAL:GOSUB 60:Y=Y-256
4340 IF X>255 THEN C%=MOVAZ:GOSUB 60:X=X-256
4350 IF Y>255 OR X>255 THEN GOTO 4330:REM loop til coarse done
4355 C%=F:GOSUB 60:REM return to fine mode (trk std)
4360 IF Y>0 THEN C%=MOVAL:GOSUB 60:Y=Y-1:GOTO 4360
4370 IF X>0 THEN C%=MOVAZ:GOSUB 60:X=X-1:GOTO 4370
4380 RETURN
4998 :
4999 :
5000 GOSUB 900:PRINT"**** CATALOG HANDLER ****":PRINT
5010 PRINT"1. Select catalog."
5020 PRINT"2. Load object #. (optional slew-to)."
5030 PRINT"3. Add/overwrite object in catalog."
5033 PRINT"4. Print catalog."
5035 PRINT"5. Exit catalogs.":GOSUB 5800:GOSUB 5900:REM print cat labels & data
5040 PRINT:INPUT"Select function... ",N$
5050 IF N$="1" THEN GOSUB 5130:GOTO 5000
5060 IF N$="2" THEN GOSUB 5300:IF FL5=1 THEN RETURN ELSE GOTO 5000:REM  FL5 requests slew-to
5070 IF N$="3" THEN GOSUB 5400:GOTO 5000
5080 IF N$="4" THEN GOSUB 44000:GOTO 5000
5082 IF N$="5" THEN RETURN
5085 IF N$="ngc" OR N$="NGC" OR N$="n" OR N$="N" THEN CAT$="NGC"
5100 GOTO 5000
5129 :
5130 GOSUB 900:PRINT"1. M (110 choice objects)":REM *** select catalog ***
5140 PRINT"2. NGC (7838 objects)"
5150 PRINT"3. IC  (5338 objects)"
5170 PRINT"4. Caldwell (Sky & Tel Dec-95 110 choice objects)"
5180 PRINT"5. King (26 cool-clusters,opn)"
5190 PRINT"6. User (100 of your own fave-raves)"
5196 N$=CAT$:PRINT:INPUT"Select catalog...",N
5200 IF N=1 THEN CAT$="M"
5210 IF N=2 THEN CAT$="NGC"
5220 IF N=3 THEN CAT$="IC"
5240 IF N=4 THEN CAT$="Caldwell"
5250 IF N=5 THEN CAT$="King"
5260 IF N=6 THEN CAT$="User"
5288 IF CAT$=N$ THEN RETURN:REM- no change in cat data displayed
5290 OBJ%=1:GOSUB 43500:REM- change of catalog, reset to object # 1 (file record zero not allowed)
5295 RETURN
5299 :
5300 REM ************************* load object/ optional slew-to
5305 IF CAT$="" THEN BEEP:INPUT"No catalog selected - Hit Ret...",N$:RETURN
5310 INPUT"Enter object number: ",OBJ%:GOSUB 45000:IF OBJ%=0 THEN RETURN:REM- test limits of obj# for cat$
5320 GOSUB 43500:REM  read data
5330 GOSUB 5800:REM print labels
5340 GOSUB 5900:REM print data
5345 IF RA%=0 AND DE%=0 THEN BEEP:INPUT"Not in catalog - Hit Ret.",N$:RETURN
5350 INPUT"Slew to it? (y/n) ",N$
5360 IF N$="Y" OR N$="y" THEN RA=RA%/1000:DE=DE%/100:FL5=1:FL10=1:REM FL5 is slew-to request, fl10 shows cat data valid to displ.
5365 ELSE FL10=0:REM else disable displ of cat data.
5370 RETURN
5399 :
5400 REM ****************************** add/revise catalog CAT$
5405 IF CAT$="" THEN BEEP:INPUT"No catalog selected - Hit Ret...",N$:RETURN
5410 ON ERROR GOTO 5560:PRINT"Enter info below, no commas in text areas please!..."
5420 LOCATE 18,6:PRINT"-----":LOCATE 18,6:INPUT"",OBJ%:GOSUB 45000:IF OBJ%=0 THEN RETURN:REM- test limits of obj# for cat
5430 LOCATE 19,6:PRINT"---------------":LOCATE 19,6:INPUT"",NM$
5440 LOCATE 20,6:PRINT"--------":LOCATE 20,6:INPUT"",CN$
5450 LOCATE 21,6:PRINT"-------------------":LOCATE 21,6:INPUT"",DES$
5460 LOCATE 22,6:PRINT"----":LOCATE 22,6:INPUT"",MAG:MAG%=MAG*10
5470 LOCATE 23,6:PRINT"---":LOCATE 23,6:INPUT"",CHART$
5480 GOSUB 900:Q$="Enter Ra (H,M):":GOSUB 21300:RA%=INT(N*1000)
5490 Q$="Enter Dec (D,M):":GOSUB 21300:DE%=INT(N*100)
5500 GOSUB 5800:GOSUB 5900:REM print cat labels & data
5530 LOCATE 10,1:INPUT"OK to save? (y/n): ",N$
5540 IF N$="Y" OR N$="y" THEN GOSUB 43000
5550 RETURN
5560 BEEP:BEEP:BEEP:RESUME 5550:REM  error in subroutine
5599 :
5799 :
5800 REM **** CATALOG LABELS LOCATE & PRINT ****
5809 LC=POS(X):LL=CSRLIN:REM- save cursor position (x=dummy argument)
5810 LOCATE 17,1
5820 PRINT"Cat:         "
5830 PRINT"Num:       "
5840 PRINT"Nam:             "
5850 PRINT"Con:           "
5860 PRINT"Des:                 "
5865 PRINT"Mag:     "
5870 PRINT"Ua#:    ";
5880 LOCATE LL,LC:RETURN:REM- restore last line, last cursor pos
5899 :
5900 REM *** print catalog data ***
5910 LC=POS(X):LL=CSRLIN:REM- save cursor position (x=dummy argument)
5920 LOCATE 17,6:PRINT CAT$
5930 LOCATE 18,5:PRINT OBJ%
5940 LOCATE 19,6:PRINT NM$
5950 LOCATE 20,6:PRINT CN$
5960 LOCATE 21,6:PRINT DES$
5965 LOCATE 22,5:PRINT USING"##.#";MAG%/10
5970 LOCATE 23,6:PRINT CHART$
5980 LOCATE 24,1:I=RA%/1000:PRINT"Ra : ";:PRINT USING"##";INT(I);:PRINT",";:PRINT USING"###";INT((I-INT(I))*6000)/100;
5981 PRINT"   Dec: ";:I=DE%/100:REM convert de% to floating point (i is DE value)
5982 IF I>-.99 AND I<0 THEN PRINT USING"###";FIX(I);:PRINT",";:PRINT USING"###";INT((I-FIX(I))*6000)/100;:GOTO 5990:REM exception for 0to-1 (-0 doesnt print)
5983 PRINT USING"+##";FIX(I);:PRINT",";:PRINT USING"###";INT(ABS(I-FIX(I))*6000)/100;:REM print dec in +/-H,M if aligned
5990 LOCATE LL,LC:RETURN:REM- restore last line, last cursor pos
5998 :
5999 :
6000 REM 6000 block not used
7000 INPUT"Function not available - hit ret",N$:RETURN
7616 :
7617 :
7618 REM *** Entry point for auto-tracking (from main menu)
7620 C%=F:GOSUB 60:FC=F:LOCATE 20,45:PRINT"Local ":REM- set fine moves for adjusting trk pos (no A/B chg), displ local pan.
7621 KEY(11) ON:KEY(12) ON:KEY(13) ON: KEY(14) ON:ON KEY(11) GOSUB 7650:ON KEY(12) GOSUB 7670:ON KEY(13) GOSUB 7680:ON KEY(14) GOSUB 7660:FL4=1:GOSUB 9000:REM- set pan keys,trk flg, display "TRK:ON" status
7622 KEY(0)STOP:GOSUB 4049:KEY(11)ON:KEY(12)ON:KEY(13)ON:KEY(14)ON:REM  slew to ra/dec (calcs HA,AL,AZ fr LST clk,lat)...stop key int's when moving.
7640 N$=INKEY$:IF N$="" THEN 7622:REM- if no keys, loop
7645 FL4=0:GOSUB 9000:KEY(11) OFF:KEY(12) OFF:KEY(13) OFF:KEY(14) OFF:RETURN:REM- key traps off, menu item selected, displ trk off, return
7648 :
7649 REM- if cursor keys, move without changing A/B absol position.
7650 KEY(12)STOP:KEY(13)STOP:KEY(14)STOP:C1%=C%:C%=U:GOSUB 60:GOSUB 36000:C%=MOVAL:FOR N= 1 TO 20:GOSUB 60:NEXT:C%=C1%:RETURN:REM- up fine steps w/BLASH
7660 KEY(11)STOP:KEY(12)STOP:KEY(13)STOP:C1%=C%:C%=D:GOSUB 60:GOSUB 36000:C%=MOVAL:FOR N= 1 TO 20:GOSUB 60:NEXT:C%=C1%:RETURN:REM- dn fine steps w/BLASH
7670 KEY(11)STOP:KEY(13)STOP:KEY(14)STOP:C1%=C%:C%=L:GOSUB 60:GOSUB 36000:C%=MOVAZ:FOR N= 1 TO 20:GOSUB 60:NEXT:C%=C1%:RETURN:REM- L fine steps w/BLASH
7680 KEY(11)STOP:KEY(12)STOP:KEY(14)STOP:C%=C1%:C%=R:GOSUB 60:GOSUB 36000:C%=MOVAZ:FOR N= 1 TO 20:GOSUB 60:NEXT:C%=C1%:RETURN:REM- R fine steps w/BLASH
7698 :
7699 :
7700 REM *** 1 SEC INTERRUPT ROUTINE.  CAUTION! timer int sometimes spans 2 sec of time (just before end of prior pc tick and just past current tic).
7710 LC1=POS(X):LL1=CSRLIN:REM- save cursor position (x=dummy argument), different from other cursor saves cause this one may INTERRUPT another saved cursor.
7730 LOCATE 22,61:PRINT TIME$:REM- print current clock in 0-24hr time.
7735 LOCATE 23,60:PRINT LSTADJ;",";TRIMSIGN;"    ":REM- show Trim countdown to 1-sec adjust, and its sign val.
7740 GOSUB 8980:GOSUB 8984:REM  update & disp AL,AZ position also.
7750 LOCATE LL1,LC1:REM- restore last line, last cursor pos.
7759 :
7760 REM  Maintain LST adjustment. LST is 1/365th faster than solar time. 365 seconds will elapse before a PC-clock +1 Sec adjust is needed (6.083M or 10S/Hr).
7762 REM- on Daves xp desktop, DOS pseudo-clock runs ahead variably, A TIMER_STOP is auto executed on int, then re enabled upon return.
7770 LSTADJ=LSTADJ-1:REM  countdown elapsed seconds since last LST adjustment (1st initialized @ align in 46295).
7780 IF LSTADJ>0 THEN RETURN:REM  if not at trim cal point yet exit. LSTTRIM is user-modified in cal section, saved on disk, & loaded when scope.cal is.
7789 :
7790 REM  adjustment needed. IMPORTANT NOTE- The act of writing to time$ does not clear fractions on XP-home edition circa 2005, clk varies rate by itself too for reasons unknown.
7800 LSTADJ=LSTTRIM:TEMPTIME$=TIME$:REM  set next count, latch the time instant.
7810 H1=VAL(MID$(TEMPTIME$,1,2)):REM  numeric hrs 0-23.
7820 M1=VAL(MID$(TEMPTIME$,4,2)):REM  numeric min 0-59.
7830 S1=(VAL(MID$(TEMPTIME$,7,2)))+(1*TRIMSIGN):REM  read numeric sec 0-59, plus 1sec x trim sign (which contains + 1 or -1) for +/- 1sec correction.
7840 IF S1<0 THEN S1=0:REM- if sec rolled under (rare) make no change.
7850 IF S1>59 THEN S1=59:REM- is sec rolled over (rare) make no change.
7860 :
7880 TEMPTIME$=MID$(STR$(H1),2,2)+":"+MID$(STR$(M1),2,2)+":"+MID$(STR$(S1),2,2):TIME$=TEMPTIME$:REM- install the updated PC clock time. This does not show on WinXP taskbar, but does well on time$ in BASICA.
7910 :
7920 BEEP:REM signify a time correction.
7990 RETURN
7998 :
7999 :
8000 GOSUB 900:PRINT:PRINT"Manual Pan..."
8005 FL10=0:REM  disable screen display of cat data.
8010 PRINT:PRINT"Use cursor keys."
8020 PRINT"F2 to change Pan size.":PRINT"Hit F1 when done."
8022 FC=F:GOSUB 8910:REM- init fine, gosub toggles to coarse & displays
8024 GOSUB 8965:REM- print all data
8030 I=0:KEY(1) ON:KEY(2) ON:KEY(11) ON:KEY(12) ON:KEY(13)ON:KEY(14) ON
8040 ON KEY(1) GOSUB 8400  :REM F1 quit
8042 ON KEY(2) GOSUB 8900 :REM F2 CHANGE PAN COARSE/FINE
8050 ON KEY(11) GOSUB 8500 :REM up
8060 ON KEY(12) GOSUB 8600 :REM left
8070 ON KEY(13) GOSUB 8700 :REM right
8080 ON KEY(14) GOSUB 8800 :REM down
8089 REM-  if exiting,set al/az deg,ls time, & get new ra/dec (ra/dec converts only if aligned)
8090 Y1=A*DSAL:X1=B*DSA:GOSUB 22000:GOSUB 35000:GOSUB 8988:GOSUB 8992:REM  calc & displ ra/de, subroutines just return if no alignment
8095 GOSUB 8980:GOSUB 8984:REM print alt/az deg (clk int also does it if on)
8097 IF I=1 THEN RETURN
8100 GOTO 8090
8399 :
8400 KEY(1)OFF:KEY(11)OFF:KEY(12)OFF:KEY(13)OFF:KEY(14)OFF:I=1:RETURN
8488 :
8489 :
8490 REM- up, maintain step pos (A)
8500 KEY(12)OFF:KEY(13)OFF:KEY(14)OFF
8502 C%=U:GOSUB 60:IF DIRA=0 THEN GOSUB 36000:REM- send up cmd & call blash
8505 C%=MOVAL:GOSUB 60:IF FC=C THEN A=A+256:GOTO 8515
8510 FOR N=1 TO 7:GOSUB 60:NEXT:A=A+8
8515 KEY(12)ON:KEY(13)ON:KEY(14)ON
8520 RETURN
8589 :
8590 REM - left, maintain az step position (B)
8600 KEY(11)OFF:KEY(13)OFF:KEY(14)OFF
8602 C%=L:GOSUB 60:IF DIRB=1 THEN GOSUB 36000:REM- send left cmd & call blash
8605 C%=MOVAZ:GOSUB 60:IF FC=C THEN B=B-256:GOTO 8610
8607 FOR N=1 TO 7:GOSUB 60:NEXT:B=B-8
8610 IF B<0 THEN GOSUB 40000:REM- adj b for 0-360 range if necc
8615 KEY(11)ON:KEY(13)ON:KEY(14)ON
8620 RETURN
8689 :
8690 REM - right, maintain position data (B)
8700 KEY(11)OFF:KEY(12)OFF:KEY(14)OFF
8702 C%=R:GOSUB 60:IF DIRB=0 THEN GOSUB 36000:REM- send right cmd & call blash
8705 C%=MOVAZ:GOSUB 60:IF FC=C THEN B=B+256:GOTO 8710
8707 FOR N=1 TO 7:GOSUB 60:NEXT:B=B+8
8710 IF FL3=1 AND B>BMAX THEN GOSUB 40000:REM- adj b for 0-360 range, but not if unaligned (encoding cal uses B & this routine to count)
8715 KEY(11)ON:KEY(12)ON:KEY(14)ON
8720 RETURN
8789 :
8790 REM - dn, maintain alt step position (A)
8800 KEY(11)OFF:KEY(12)OFF:KEY(13)OFF
8802 C%=D:GOSUB 60:IF DIRA=1 THEN GOSUB 36000:REM- send dn cmd & call blash
8805 C%=MOVAL:GOSUB 60:IF FC=C THEN A=A-256:GOTO 8815
8810 FOR N=1 TO 7:GOSUB 60:NEXT:A=A-8
8815 KEY(11)ON:KEY(12)ON:KEY(13)ON
8820 RETURN
8899 :
8900 REM- toggle pan... coarse/fine
8910 IF FC=C THEN FC=F:C%=F:GOSUB 60:LOCATE 20,45:PRINT"Fine  ":RETURN:REM if coarse set fine
8920 IF FC=F THEN FC=C:C%=C:GOSUB 60:LOCATE 20,45:PRINT"Coarse":REM if fine set coarse
8930 RETURN:REM- if above ifs do not work
8949 :
8950 REM **** data readout subroutines
8960 LOCATE 18,38:PRINT"Scope: ";:PRINT SCOPE$:LOCATE 19,40:PRINT"Lat:":LOCATE 20,40:PRINT"Pan:":LOCATE 21,40:PRINT"Trk:":LOCATE 18,57:PRINT"Ra:":LOCATE 19,56:PRINT"Dec:":LOCATE 20,56:PRINT"Alt:":LOCATE 21,57:PRINT"Az:"
8962 LOCATE 22,39:PRINT"Port:":LOCATE 22,56:PRINT"LST:":LOCATE 23,55:PRINT"Trim:":REM- print label setups
8965 GOSUB 8970:GOSUB 8980:GOSUB 8984:GOSUB 8988:GOSUB 8992:GOSUB 9000:RETURN:REM PRINT ALL DATA
8970 LOCATE 19,44:IF GP=0 THEN RETURN ELSE PRINT INT(GP*100)/100"    ":REM PRINT LATITUDE in hundredths
8972 RETURN
8980 LOCATE 20,62:IF FL1=0 THEN RETURN ELSE PRINT USING"##.##";A*DSAL:REM PRINT ALT DEGREES IN HUNDREDTHS
8982 RETURN
8984 LOCATE 21,61:IF FL2=0 THEN RETURN ELSE PRINT USING"###.##";B*DSA:REM PRINT AZ DEGREES IN HUNDREDTHS
8986 RETURN
8988 IF FL3=0 THEN RETURN ELSE LOCATE 18,62:PRINT USING"##";INT(RA);:PRINT",";:PRINT USING"###";INT((RA-INT(RA))*6000)/100:REM print ra in H,M if aligned
8990 RETURN
8992 IF FL3=0 THEN RETURN ELSE LOCATE 19,61:IF DE>-.99 AND DE<0 THEN PRINT USING"###";FIX(DE);:PRINT",";:PRINT USING"###";INT((DE-FIX(DE))*6000)/100:GOTO 8994:REM exception for 0to-1 (-0 doesnt print)
8993 LOCATE 19,61:PRINT USING"+##";FIX(DE);:PRINT",";:PRINT USING"###";INT(ABS(DE-FIX(DE))*6000)/100:REM print dec in +/-H,M if aligned
8994 RETURN
8998 RETURN
9000 LOCATE 21,45:IF FL4=0 THEN PRINT"Off" ELSE PRINT"On ":REM displ trk status
9008 LOCATE 22,45:IF FL9=1 THEN PRINT"Offline":RETURN:REM displ port connection
9010 IF OU=888 THEN PRINT"0378"
9012 IF OU=956 THEN PRINT"03BC"
9014 IF OU=64728! THEN PRINT"FCD8"
9016 IF OU=64744! THEN PRINT"FCE8"
9020 RETURN
19984 :
19986 :
19988 REM *** convert HA/DEC to ALT/AZ (radians)
19990 :
19992 REM   INPUTS (degrees)                  OUTPUTS (degrees)
19994 REM   GP- Geographical Latitude
19996 REM   X1 - Hour angle (or Azimuth)      P - Azimuth (or hour angle)
19998 REM   Y1 - Declination (or Altitude)    Q - Altitude (or Declination)
20000 :
20500 IF FL4=0 THEN GP1=GP*.017453292#:REM- convert degrees to radians (GP prime) if not tracking (FL4)
20502 X1=X1*.017453292#:Y1=Y1*.017453292#
20510 CF=COS(GP1):SF=SIN(GP1)
20515 SY=SIN(Y1):CY=COS(Y1)
20520 SX=SIN(X1):CX=COS(X1)
20525 J=(SY*SF)+(CY*CF*CX)
20530 Q=FNS(J):CQ=COS(Q):K=CF*CQ
20535 IF K<1E-10 THEN K=1E-10
20540 CP=(SY-(SF*J))/K:IF CP <-1 THEN CP=-1
20541 IF CP>1 THEN CP=1
20542 P=FNC(CP)
20545 IF SX>0 THEN P=6.283185308#-P
20550 P=P*57.29578:Q=Q*57.29578:REM- conv rad back to degrees
20570 RETURN
20580 :
20999 :
21299 :
21300 REM *** Subroutine - Input HorD,M...conv to just decimal
21305 REM  q$=prompt  n=returned#  z=sign variable
21310 PRINT Q$;:INPUT H$,M$
21315 Z=1:IF MID$(H$,1,1)="-" OR MID$(M$,1,1)="-" THEN Z=-1
21320 N=ABS(VAL(H$))+ABS(VAL(M$)/60):N=N*Z:REM conv N to decimal hrs or deg
21330 RETURN
21997 :
21998 :
21999 REM *** load LS with current LST in hours. Maintain fractional seconds between clock seconds increments (of the timer int routine @ 7700).
22000 LATCH$=TIME$:REM  we latch here cause timer int doesnt sync w/pc clock, s/b more accurate.  Avoids crossing 2 sec between samps
22010 H=VAL(MID$(LATCH$,1,2)):REM  conv hrs/min/sec
22012 M=VAL(MID$(LATCH$,4,2))
22014 S=VAL(MID$(LATCH$,7,2))
22016 LOOP=LOOP+1:REM- inc loop count between clock seconds.
22018 IF S<>LASTS THEN LASTS=S:SPL=(SPL+(1/LOOP))/2:LOOP=0:REM- if pc clock ticked, update sec-per-loop stuff, SPL becomes last two averaged.
22030 REM- add fractional seconds via Sec-per-Loop x LOOP.
22032 SPLTOT=SPL*LOOP
22033 S=S+SPLTOT
22035 S=S/3600:REM- when S is 0 this returns a zero.
22037 M=M/60
22040 LS=H+M+S
22050 RETURN
22098 :
22099 :
33799 :
33899 :
34900 LOCATE 19,1:REM - clear window area
34910 FOR N=1 TO 5
34920 FOR I=1 TO 30:PRINT " ";:NEXT I
34930 PRINT:NEXT N
34940 LOCATE 19,1:RETURN:REM position cursor to top left of window
34997 :
34998 :
34999 REM *** calc HA/Ra/Dec given y1(al deg) x1(az deg) ls(hrs) gp(deg)
35000 IF FL3=0 THEN RETURN:REM  only performed if aligned
35010 GOSUB 20500:HA=P/15:DE=Q
35020 RA=LS-HA
35030 IF RA<0 THEN RA=RA+24:GOTO 35030
35040 IF RA>24 THEN RA=RA-24:GOTO 35040
35050 RETURN
35497 :
35498 :
35499 REM- convert ra/de (hours/deg) to alt/az deg, uses LS hrs & GP deg
35500 HA=LS-RA
35514 IF HA<0 THEN HA=HA+24
35530 X1=HA*15:Y1=DE:GOSUB 20500:RETURN:REM Q is alt, P is az
35598 :
35599 :
35998 :
35999 :
36000 REM ******** Backlash routine
36001 REM  call when c% shows U,D,L,R to run backlash operation
36002 REM  fine/coarse code FC is reinstalled on dob after bl fine moves.
36003 REM  dira/b bit is toggled if different direction from last check.
36004 REM    The dir bit should only be changed by this blash routine.
36005 REM  c% is restored to u,d,l,r as was on entry.
36006 REM  blash does NOT update positions, in fact it's the primary purpose
36010 IF C%=L AND DIRB=1 THEN N=BLVALB ELSE GOTO 36020
36012 IF N>256 THEN C%=C:GOSUB 60:C%=MOVAZ:GOSUB 60:N=N-256
36014 C%=F:GOSUB 60:C%=MOVAZ:GOSUB 36100:DIRB=0:C%=FC:GOSUB 60:C%=L:RETURN
36019 :
36020 IF C%=R AND DIRB=0 THEN N=BLVALB ELSE GOTO 36030
36022 IF N>256 THEN C%=C:GOSUB 60:C%=MOVAZ:GOSUB 60:N=N-256
36024 C%=F:GOSUB 60:C%=MOVAZ:GOSUB 36100:DIRB=1:C%=FC:GOSUB 60:C%=R:RETURN
36029 :
36030 IF C%=U AND DIRA=0 THEN N=BLVALA ELSE GOTO 36040
36032 IF N>256 THEN C%=C:GOSUB 60:C%=MOVAL:GOSUB 60:N=N-256
36034 C%=F:GOSUB 60:C%=MOVAL:GOSUB 36100:DIRA=1:C%=FC:GOSUB 60:C%=U:RETURN
36039 :
36040 IF C%=D AND DIRA=1 THEN N=BLVALA ELSE GOTO 36050
36042 IF N>256 THEN C%=C:GOSUB 60:C%=MOVAL:GOSUB 60:N=N-256
36044 C%=F:GOSUB 60:C%=MOVAL:GOSUB 36100:DIRA=0:C%=FC:GOSUB 60:C%=D:RETURN
36050 RETURN
36098 :
36099 REM ****** faster output routine, for blash steps
36100 FOR I=1 TO N:GOSUB 60:NEXT
36170 RETURN
36998 :
36999 :
37000 REM *** subroutine - enable clock interrupt ea second
37010 TIMER ON:ON TIMER(1) GOSUB 7710:REM- enable 1 sec interrupt to 7710
37020 RETURN
37999 :
38000 REM *** subr- load LST into PC via TIME$ using HA & RA. Win XP and others maintain time$ separately from the displayed clock, unlike earlier versions. But it appears to work fine.
38010 X=HA+RA:REM  x=local sidereal time in hours
38020 IF X>24 THEN X=X-24:PRINT"-24 in line 38020":GOTO 38020:REM- entry point for other routines with X in hrs.
38030 IF X<0 THEN X=X+24:PRINT"+24 in line 38030":GOTO 38030
38040 N=X     :REM   copy x hours
38050 X=INT(X):REM   x=integer hours
38060 Y=N-X:REM Y=fractional remainder of hours
38070 Y=Y*60    :REM y=minutes & fraction
38080 N=Y       :REM copy
38090 Y=INT(Y)  :REM y=integer minutes
38100 Z=N-Y:REM z=fractional remainder of minutes
38110 Z=INT(Z*60):REM z=seconds
38120 TIME$=MID$(STR$(X),2,2)+":"+MID$(STR$(Y),2,2)+":"+MID$(STR$(Z),2,2)
38130 RETURN
38299 :
39000 REM *** calculate HA in hours from alt/az pos (a,b) & GP
39010 X1=B*DSA:Y1=A*DSAL:REM  convert steps to degrees
39020 GOSUB 20000:REM  get HA(p) from alt/az degrees & GP
39030 HA=P/15:REM  conv the degrees to hours
39040 RETURN
39050 :
39999 :
40000 REM- ck b pos, adj if >360 or <0 deg
40010 IF B>BMAX THEN B=B-BMAX:REM- bmax is 360 deg point
40020 IF B<0 THEN B=B+BMAX
40030 RETURN
40997 :
40998 :
40999 REM ********************************************
41000 REM- subr - Write cal data to sequential file "scope$".
41010 REM- DSAL,DSA,BLVALA,BLVALB,EOF
41020 REM- All data must be valid before writing. All saved as strings.
41030 REM-
41040 REM-
41050 REM-
41060 OPEN "O",#1,SCOPE$
41080 PRINT#1,STR$(DSAL);",";STR$(DSA);",";STR$(BLVALA);",";STR$(BLVALB)
41090 CLOSE #1:RETURN
41498 :
41499 REM **********************************************
41500 REM- subr - Read cal data from sequential file "scope$", then LSTTRIM.CAL
41510 REM- dsal, dsa, blvala, blvalb,eof
41520 REM- All data converted from strings to numeric
41530 REM
41540 REM
41550 ON ERROR GOTO 41590
41555 OPEN "I",#1,SCOPE$
41560 INPUT#1,DSAL$,DSA$,BLVALA$,BLVALB$
41570 DSAL=VAL(DSAL$):DSA=VAL(DSA$):BLVALA=VAL(BLVALA$):BLVALB=VAL(BLVALB$)
41580 CLOSE #1
41583 GOSUB 61500:REM- get LSTTRIM cal data from diskfile.
41588 RETURN
41590 PRINT"Error# ";ERR;" in 41590
41593 INPUT"File not valid - hit return...",N:CLOSE #1:RESUME 41595
41595 ON ERROR GOTO 0
41600 RETURN 50
41997 :
41998 :
41999 :
42000 REM ************************
42010 REM- subr - CAL AZ(Ra) BLASH
42020 :
42030 :
42040 TIMER OFF:CLS:REM  disable timer int so screen isnt printed upon.
42060 PRINT"Calibrate Az backlash...":GOSUB 42300:REM  type info page
42070 C%=L:GOSUB 60:GOSUB 36000:REM set dir & go blash.
42080 GOSUB 42200:IF N$=CHR$(13) THEN GOTO 42150:REM  key ck
42085 C%=R:GOSUB 60:GOSUB 36000:REM set opposite dir & go blash.
42090 GOSUB 42200:REM  key ck
42150 IF N$=CHR$(13) THEN TIMER ON:N=0:RETURN:REM  enable clock int, clr menu item N, exit.
42160 GOTO 42070
42199 :
42200 REM  subr- increase/decrease value
42210 N$=INKEY$:IF N$="i" OR N$="I" THEN BLVALB=BLVALB+1
42220 IF N$="d" OR N$="D" THEN BLVALB=BLVALB-1:IF BLVALB<0 THEN BLVALB=0
42230 LOCATE 3,27:PRINT"     ":LOCATE 3,27:PRINT BLVALB
42240 RETURN
42299 :
42300 PRINT:REM  subr-list blash cal screen info
42310 PRINT"Current Backlash Steps:                  I=increase."
42320 PRINT"                                         D=decrease."
42330 PRINT:PRINT"Procedure:"
42340 PRINT"Use medium to high-power eyepiece on stationary object (daytime or polar area)."
42350 PRINT"The motor is now slewing back & forth the distance of backlash value above."
42360 PRINT"Incease value until bright stars 'jump' every second or so."
42370 PRINT"Decrease value until the jump gets smaller, then no longer occurs."
42380 PRINT"Hit Return to exit."
42390 PRINT:PRINT"Description:"
42400 PRINT"Accurate backlash values are CRUCIAL to positioning accuracy.  Backlash is the  'looseness' of the drive train, belt stretch, mount torsion, etc."
42410 PRINT"You can feel this by moving the tube back & forth gently by hand with the drive engaged (don't do it now!).  When the stepper motor has been moving one         direction, and is commanded to move the opposite direction, this looseness must"
42415 PRINT"be taken-up because the tube will not move the other way until then.
42420 PRINT"The backlash value tells how many motor steps are required to take out the      looseness, so the computer will take it into account for slewing/aligning and   cursor key movements.
42430 PRINT"The tube must be well balanced at all observing angles."
42440 RETURN
42497 :
42498 :
42499 :
42500 REM ************************
42510 REM- subr - CAL AL(De) BLASH
42520 :
42530 :
42540 TIMER OFF:CLS:REM  disable timer int so screen isnt printed upon.
42560 PRINT"Calibrate Altitude backlash...":GOSUB 42300:REM  type info page
42570 C%=U:GOSUB 60:GOSUB 36000:REM set dir & go blash.
42580 GOSUB 42800:IF N$=CHR$(13) THEN GOTO 42650:REM  key ck
42585 C%=D:GOSUB 60:GOSUB 36000:REM set opposite dir & go blash.
42590 GOSUB 42800:REM  key ck
42650 IF N$=CHR$(13) THEN TIMER ON:N=0:RETURN:REM  enable clock int, clr menu item N, exit.
42660 GOTO 42570
42799 :
42800 REM  subr- increase/decrease value
42810 N$=INKEY$:IF N$="i" OR N$="I" THEN BLVALA=BLVALA+1
42820 IF N$="d" OR N$="D" THEN BLVALA=BLVALA-1:IF BLVALA<0 THEN BLVALA=0
42830 LOCATE 3,27:PRINT"     ":LOCATE 3,27:PRINT BLVALA
42840 RETURN
42899 :
42997 :
42998 :
42999 :
43000 REM ********************************* write random cat$ file
43010 REM  cat$ is filename max 8digits.xxx
43020 REM  obj% is object number (record no.) 99000 max per cat
43030 REM  nm$  is name of object 12 digits string, 15 byt
43040 REM  cn$  is constellation of object - 5 digits string, 8 byt
43050 REM  des$ is description of object - 16 digits string, 19 byt
43060 REM  mag% is magnitude of object x 10 (10.0=100), 2 byt
43070 REM  chart$ is UA chart # 3 digits string, 6 byt
43080 REM  ra% is xx.xxx  x  1000 (24.000 is stored as 24000) 2 byt
43090 REM  de% is xx.xx  x  100 (-90.00=-9000) 2 byt
43100 OPEN "R",#1,CAT$,55:REM 55 bytes length is 5 extra just in case
43110 FIELD #1, 15 AS FILENM$, 8 AS FILECN$, 19 AS FILEDES$, 2 AS FILEMAG$, 3 AS FILECHART$, 2 AS FILERA$, 2 AS FILEDE$
43120 LSET FILENM$=NM$:LSET FILECN$=CN$:LSET FILEDES$=DES$:LSET FILEMAG$=MKI$(MAG%):LSET FILECHART$=CHART$:LSET FILERA$=MKI$(RA%):LSET FILEDE$=MKI$(DE%)
43130 PUT #1,OBJ%:CLOSE #1:RETURN
43497 :
43498 :
43499 :
43500 REM ********************************* read random cat$ file
43510 REM  data returned just as supplied written, above
43515 IF CAT$="" THEN INPUT"No catalog selected - Hit ret...",N:RETURN 5000
43517 REM ON ERROR GOTO 43570
43520 OPEN "R",#1,CAT$,55:REM 55 bytes length is 5 extra just in case
43530 FIELD #1, 15 AS FILENM$, 8 AS FILECN$, 19 AS FILEDES$, 2 AS FILEMAG$, 3 AS FILECHART$, 2 AS FILERA$, 2 AS FILEDE$
43540 GET #1,OBJ%
43550 NM$=FILENM$:CN$=FILECN$:DES$=FILEDES$:MAG%=CVI(FILEMAG$):CHART$=FILECHART$:RA%=CVI(FILERA$):DE%=CVI(FILEDE$)
43555 IF MAG%=0 AND RA%=0 AND DE%=0 THEN FL6=1:REM  no file record
43560 CLOSE #1:RETURN
43570 INPUT"File not valid - Hit Ret... ",N$:CLOSE#1:RETURN 5000
43997 :
43998 :
43999 :
44000 REM ******************* PRINT CATALOG *********************
44010 REM
44020 REM
44030 REM
44040 REM
44050 REM
44100 IF CAT$="" THEN BEEP:INPUT"No catalog selected - Hit ret...",N:RETURN 5000
44105 IF OBJ%=0 THEN OBJ%=1:REM- zero not allowed for file access
44110 GOSUB 900:PRINT"***** Print Catalog Data *****"
44120 PRINT"This will print a range of object numbers you specify from the currently        selected catalog, which is... ";CAT$
44130 PRINT"For example, entering 1 to 10 will list the first 10 objects in the catalog,    2000 to 3000 will print 1000 objects number 2000 through 3000!
44140 PRINT"This activity will not change the status of the program or the telescope if you don't move the instrument."
44150 PRINT"Disconnect telescope cord if present and connect printer...Hit Ret or Esc."
44160 N$=INKEY$:IF N$="" THEN 44160
44170 IF N$=CHR$(13) THEN 44190:REM  only if ret, then continue
44180 RETURN
44190 INPUT"Print From Object#: ",N%:IF N%=0 THEN N%=1:REM no zero file record allowed
44200 INPUT"        To Object#: ",I%:OBJ%=I%:GOSUB 45000:IF OBJ%=0 THEN RETURN:REM- test limits of obj# for cat$
44210 PRINT"Hit any key to stop listing."
44220 PRINT:PRINT"CAT: "CAT$;"  From#";N%;"To";I%;"      ****TECH2000****"
44230 PRINT:PRINT"OBJECT  NAME             CONSTELL  DESCRIPTION           MAG   UA    RA     DEC  "
44240 FOR OBJ%=N% TO I%
44250 FL6=0:GOSUB 43500:IF FL6=1 THEN FL6=0:GOTO 44340:REM FL6=no file
44260 PRINT USING"#####";OBJ%;
44270 PRINT"   ";:PRINT USING"\             \";NM$;
44280 PRINT"  ";:PRINT USING"\      \";CN$;
44290 PRINT"  ";:PRINT USING"\                 \";DES$;
44300 PRINT"  ";:PRINT USING"##.#";MAG%/10;
44310 PRINT"  ";:PRINT USING"\ \";CHART$;
44320 PRINT"  ";:PRINT USING"##.##";RA%/1000;
44330 PRINT"  ";:PRINT USING"+##.##";DE%/100
44340 N$=INKEY$:IF N$="" THEN NEXT
44350 RETURN
44498 :
44499 :
44500 CLS:PRINT"Catalog file init prog - run 44500 to use it."
44510 INPUT"Exact cat$ name: ",CAT$
44520 INPUT"From object# : ",N
44530 INPUT"To object# : ",I:LOCATE 15,1:PRINT"setting up rec#: "
44550 FOR OBJ%=N TO I:LOCATE 15,20:PRINT OBJ%
44560 GOSUB 43000:REM- write cat$ record (all nulls & 0's) to random file
44570 NEXT
44580 END
44998 :
44999 :
45000 REM ***** check catalog limits *****
45010 IF OBJ%<1 THEN RETURN: REM- nogo if record=< 0
45020 IF CAT$="M" AND OBJ%<111 THEN RETURN
45030 IF CAT$="NGC" AND OBJ%<7839 THEN RETURN
45040 IF CAT$="IC" AND OBJ%<5339 THEN RETURN
45050 IF CAT$="Caldwell" AND OBJ%<111 THEN RETURN
45060 IF CAT$="King" AND OBJ%<27 THEN RETURN
45070 IF CAT$="User" AND OBJ%<101  THEN RETURN
45080 INPUT"Outside catalog range - Hit ret.",N$:OBJ%=0:RETURN
45997 :
45998 :
45999 :
46000 REM *********************************************
46010 REM        2-star align, DM style
46020 REM *********************************************
46030 REM  level-me function not needed!
46040 REM
46050 REM
46060 CLS:LOCATE 8,1
46070 PRINT"2-STAR ALIGN...DM STYLE"
46080 PRINT"Best results when reference stars are separated by more than 45 degrees."
46090 PRINT"And lie between 20 to 50 degrees elevation (35 +/- 15 degrees)."
46100 PRINT"Hit any key..."
46110 N$=INKEY$:IF N$="" THEN GOTO 46110
46129 :
46130 GOSUB 3200:REM  ref list, pan to it, ra/de returned
46135 IF N=0 THEN RETURN:REM  no star was selected (escapes)
46140 RA1=RA:DE1=DE:REM  SAVE REF 1 COORD
46148 IF FL11=0 THEN PCCLK$=TIME$:REM save syst clk for re-calc @ exit time.  Do only once in case re-align is done or flying align (flg set below 46281).
46150 X=0:GOSUB 38020:TIMER ON:ON TIMER(1) GOSUB 7710:REM set time=0, enable int
46160 B=0:A=0:REM  zero position a/b (centered on ref 1)
46179 :
46180 GOSUB 3200:REM get ref 2 ra/de
46185 IF N=0 THEN RETURN:REM  no star was selected (escapes)
46210 RA2=RA:DE2=DE:REM  SAVE REF 2 COORD
46220 GOSUB 22000:LS2=LS:REM  fetch ls elapsed time & save as ls2 time offset
46230 B=B*DSA:IF B>180 THEN B=B-360:REM  az offset= +/-180 deg
46235 A=A*DSAL:REM alt offset= +/- 90 deg
46240 REM  set up and call for ea best fit pass, coarse/med/fine
46249 MINDIF=270:CLS:LOCATE 12,23:PRINT"COMPUTING BEST FIT ALST"
46250 :
46252 LSX=0:LSY=20:LSZ=4
46254 GPX=-50:GPY=50:GPZ=20:GOSUB 46300:REM               6X6 Coarse
46256 :
46258 LSX=BLS-3:LSY=BLS+3:LSZ=1
46260 GPX=BGP-15:GPY=BGP+15:GPZ=5:GOSUB 46300:REM         7x7
46262 :
46264 LSX=BLS-.75:LSY=BLS+.75:LSZ=.3
46265 GPX=BGP-3.75:GPY=BGP+3.75:GPZ=1.5:GOSUB 46300:REM   6x6
46266 :
46267 LSX=BLS-.21:LSY=BLS+.21:LSZ=.07
46268 GPX=BGP-1.12:GPY=BGP+1.12:GPZ=.56:GOSUB 46300:REM   7x5
46269 :  REM - flying align may enter here...
46270 LSX=BLS-.054:LSY=BLS+.054:LSZ=.018
46271 GPX=BGP-.42:GPY=BGP+.42:GPZ=.14:GOSUB 46300:REM     7x7
46272 :
46273 LSX=BLS-.012:LSY=BLS+.012:LSZ=.004
46274 GPX=BGP-.1:GPY=BGP+.1:GPZ=.04:GOSUB 46300:REM       7x6
46275 :
46276 LSX=BLS-.003:LSY=BLS+.003:LSZ=.001
46277 GPX=BGP-.03:GPY=BGP+.03:GPZ=.01:GOSUB 46300:REM     7x7 Fine
46278 :
46280 GOSUB 22000:X=BLS+LS:GOSUB 38020:FL3=1:REM  set clock @ best(refers to ref1) + elapsed time to now.  align flg on
46281 IF FL11=0 THEN RUNCLK$=TIME$:FL11=1:REM save initial lst clk for syst clk calc @ exit, set flg so only done once.
46282 RA=RA2:DE=DE2:REM assure current ref loc is installed for slew
46283 LS=BLS+LS2:GP=BGP:GOSUB 35500:A=Q/DSAL:B=P/DSA:REM set current scope step pos (was ra2/de2 at time of ref2).
46284 RA1=RA2:DE1=DE2:LS2=LS:REM  save current ref pos & time for next adjust.
46290 CLS:LOCATE 11,25:PRINT USING"Math Altaz Warp Degrees:  ##.##";MINDIF
46293 :
46294 BEEP:BEEP:BEEP:LOCATE 14,25:INPUT"Hit Ret to commence tracking.",N$
46295 LSTADJ=LSTTRIM:REM- clr/sync/start LSTADJ for time adj in line 7770.
46296 RETURN
46297 :
46298 REM  subroutine - find best fit LS/GP... (BLS/BGP)...
46299 REM  1st coarse pass covers entire globe...
46300 FOR LS=LSX TO LSY STEP LSZ:REM    locations in longitude
46310  FOR GP=GPX TO GPY STEP GPZ:REM     locations in gp
46320   REM  GET REF1 ALT/AZ...
46330   RA=RA1:DE=DE1
46340   GOSUB 35500:REM  get alt(Q) az(P) deg from ra/de/ls/gp
46350   ALT1=Q:AZ1=P:REM store for later
46360   IF Q<0 THEN GOTO 46450:REM  skip if alt<0
46370   REM  GET REF2 ALT/AZ...
46380   RA=RA2:DE=DE2:LS=LS+LS2:REM  adj ls for ref 2 time instant
46390   GOSUB 35500
46400   LS=LS-LS2:REM  move time ref back to ref1
46410   IF Q<0 THEN GOTO 46450:REM  skip if alt<0
46420   REM  Save best ls/gp if min difference is better this pass...
46430   N=ABS(Q-ALT1-A)+ABS(P-AZ1-B):IF N<MINDIF THEN MINDIF=N:BLS=LS:BGP=GP
46450  NEXT GP
46460 NEXT LS
46470 RETURN
46500 :
47000 REM***********************************************
47010 REM         SLEW CONTROL + FLYING ALIGN
47020 REM***********************************************
47030 REM  FL5 flag directs RA/DE coordinate here for slew-to (line 4049).
47040 REM  No other parameters are needed, except the mount is aligned.
47050 REM  Saves pos & slews to new target, measures error & compensates d/s
47060 REM  Of course, FL4 must=0 (tracking off) when calling here.
47070 REM
47080 REM
47090 REM
47100 ALT1=A:AZ1=B:REM store step pos to measure slewed dist in steps.
47110 GOSUB 4049:GOSUB 4049:GOSUB 4049:REM slew to ra/de, do 3x to get close.
47120 DISTA=ABS(A-ALT1):DISTB=ABS(B-AZ1):REM calc slewed dist steps
47125 IF DISTB>BMAX/2 THEN DISTB=ABS(DISTB-BMAX):REM fix b if cross 0 (longest slew).
47140 IF DISTA*DSAL+DISTB*DSA<60 THEN RETURN:REM must be long slew to be of use.
47144 IF DE>50 OR DE<-50 THEN RETURN:REM errors increased if near poles - abort.
47146 IF DSAL*A>50 OR DSAL*A<20 THEN RETURN:REM errors increase if zen. or hor.
47150 CLS:LOCATE 8,1:PRINT"FLYING ALIGN AVAILABLE...":BEEP:BEEP:BEEP
47151 PRINT:PRINT"REQUIRES that last target was well centered during observation.  If not hit F1."
47152 PRINT:PRINT"If you DO NOT see the target in eyepiece or finder, and ARE NOT SURE you can    find it in 30 seconds, DO NOT use Flying-Align, just hit F1."
47153 PRINT:PRINT"THEN ONLY IF ALIGNMENT NEEDS IMPROVING, QUICKLY CENTER YOUR TARGET OBJECT AND   HIT F1.":PRINT:PRINT
47154 GOSUB 22000:ELTIME=LS:REM SAVE TIME IN HRS
47160 RA0=RA:DE0=DE:GOSUB 8020:RA=RA0:DE=DE0:REM pan-to, counts a/b +/-. Preserve ra/de so pan doesnt chg it!
47162 GOSUB 22000:IF LS-ELTIME>8.000001E-03 THEN RETURN:REM if user took over 29 sec then leave, error will be too hi (or user ignored screen).
47164 IF LS-ELTIME<.002 THEN RETURN:REM  if under 7.2 sec then no significant move or user did no move.
47170 ALT1=ABS(A-ALT1):AZ1=ABS(B-AZ1):REM calc new slewed dist steps.
47175 IF AZ1>BMAX/2 THEN AZ1=ABS(AZ1-BMAX):REM fix b if cross 0.
47180 ALT1=DISTA/ALT1:AZ1=DISTB/AZ1:REM calc factor >< 1.
47185 ALT1=(ALT1-1)/2+1:AZ1=(AZ1-1)/2+1:REM  half the amt (average)
47187 IF ABS(ALT1-1)<.001 AND ABS(AZ1-1)<.001 THEN RETURN:REM  no move or user did very minor one.  .360deg full turn, .090 deg in 90 deg turn, etc.
47190 CLS:PRINT "Factored alt cal (DSAL) by: ";:PRINT USING"#.###";ALT1
47200 PRINT "Factored  az cal (DSA)  by: ";:PRINT USING"#.###";AZ1
47210 DSAL=DSAL*ALT1:DSA=DSA*AZ1:REM  new steps/deg
47220 BMAX=INT(360/DSA):REM  reset new bmax value
47230 REM  derive new a/b position at this ra/de coord & time...
47240 GOSUB 22000:GOSUB 35500
47270 A=INT(Q/DSAL):B=INT(P/DSA)
47280 INPUT"Hit Ret...",N$:RETURN
47290 :
47300 REM  IF ABOVE WORKS OK, THEN ADD HERE A REALIGN OF LS/GP.  GOSUB 46274 'FINE' ROUTINE, SET MINDIF/BLS/BGP/LS/LS2
48000 REM ********************************************************
48002 REM         Direct slew processing - added for v4.2
48004 REM ********************************************************
48020 REM check for valid entries...
48022 IF N$<>"n" AND N$<>"N" AND N$<>"m" AND N$<>"M" AND N$<>"c" AND N$<>"C" AND N$<>"k" AND N$<>"K" AND N$<>"u" AND N$<>"U" AND N$<>"i" AND N$<>"I" THEN RETURN
48030 CLS:LOCATE 12,1:PRINT"Direct Goto - enter catalog number (m,ngc,caldwell,king,user)":PRINT"One catalog character is ok, for example ngc2030 or n2030 are both valid."
48040 N1$=N$:PRINT N$;:REM- save/print 1st character already trapped.
48050 LINE INPUT N$: REM-  get the rest of the users input
48055 IF N$="" THEN RETURN
48060 N$=N1$+N$:REM- add the first trapped character to get the whole entry
48200 IF LEFT$(N$,1)<>"n" AND LEFT$(N$,1)<>"N" THEN 48300:REM test if ngc
48210   CAT$="NGC":REM  is ngc, convert any text to zeros
48220   MID$(N$,1)="0"
48230   IF LEFT$(N$,2)="0g" OR LEFT$(N$,2)="0G" THEN MID$(N$,2)="0"
48240   IF LEFT$(N$,3)="00c" OR LEFT$(N$,3)="00C" THEN MID$(N$,3)="0"
48300 IF LEFT$(N$,1)<>"m" AND LEFT$(N$,1)<>"M" THEN 48400:REM test if M
48310   CAT$="M":REM  is M, convert any text to zeros
48320   MID$(N$,1)="0"
48400 IF LEFT$(N$,1)<>"c" AND LEFT$(N$,1)<>"C" THEN 48500:REM test if Cald.
48410   CAT$="Caldwell":REM  is Cald, convert any text to zeros
48420   MID$(N$,1)="0"
48430   IF LEFT$(N$,2)="0a" OR LEFT$(N$,2)="0A" THEN MID$(N$,2)="0"
48440   IF LEFT$(N$,3)="00l" OR LEFT$(N$,3)="00L" THEN MID$(N$,3)="0"
48450   IF LEFT$(N$,4)="000d" OR LEFT$(N$,4)="000D" THEN MID$(N$,4)="0"
48460   IF LEFT$(N$,5)="0000w" OR LEFT$(N$,5)="0000W" THEN MID$(N$,5)="0"
48470   IF LEFT$(N$,6)="00000e" OR LEFT$(N$,6)="00000E" THEN MID$(N$,6)="0"
48480   IF LEFT$(N$,7)="000000l" OR LEFT$(N$,7)="000000L" THEN MID$(N$,7)="0"
48490   IF LEFT$(N$,8)="0000000l" OR LEFT$(N$,8)="0000000L" THEN MID$(N$,8)="0"
48500 IF LEFT$(N$,1)<>"k" AND LEFT$(N$,1)<>"K" THEN 48600:REM test if King.
48510   CAT$="King":REM  is King, convert any text to zeros
48520   MID$(N$,1)="0"
48530   IF LEFT$(N$,2)="0i" OR LEFT$(N$,2)="0I" THEN MID$(N$,2)="0"
48540   IF LEFT$(N$,3)="00n" OR LEFT$(N$,3)="00N" THEN MID$(N$,3)="0"
48550   IF LEFT$(N$,4)="000g" OR LEFT$(N$,4)="000G" THEN MID$(N$,4)="0"
48599 :
48600 IF LEFT$(N$,1)<>"i" AND LEFT$(N$,1)<>"I" THEN 48700:REM test if IC.
48610   CAT$="IC":REM  is IC, convert any text to zeros
48620   MID$(N$,1)="0"
48630   IF LEFT$(N$,2)="0c" OR LEFT$(N$,2)="0C" THEN MID$(N$,2)="0"
48700 IF LEFT$(N$,1)<>"u" AND LEFT$(N$,1)<>"U" THEN 48800:REM test if User.
48710   CAT$="User":REM  is User, convert any text to zeros
48720   MID$(N$,1)="0"
48730   IF LEFT$(N$,2)="0s" OR LEFT$(N$,2)="0S" THEN MID$(N$,2)="0"
48740   IF LEFT$(N$,3)="00e" OR LEFT$(N$,3)="00E" THEN MID$(N$,3)="0"
48750   IF LEFT$(N$,4)="000r" OR LEFT$(N$,4)="000R" THEN MID$(N$,4)="0"
48800 OBJ%=CSNG(VAL(N$)):REM- convert to object integer
48810 GOSUB 45000:IF OBJ%=0 THEN RETURN:REM- test cat limits, if bad then ret
48820 GOSUB 43500:REM- read data from disk
48830 IF RA%=0 AND DE%=0 THEN BEEP:INPUT"Not in Catalog - Hit Enter.",N$:RETURN
48840 RA=RA%/1000:DE=DE%/100:FL5=1:REM- convert cat coord, fl5=slew request
48850 FL10=1:PRINT:PRINT"SLEWING TELESCOPE":REM fl10 for cat info displ enable
48999 RETURN
49000 REM ******************************************************
49010 REM        compute & reinstall PC clock time (time of day)
49020 REM ******************************************************
49030 REM time$ is system clock, pcclk$(syst time saved) & runclk$(lst initial time) are saved at align.
49040 :
49050 REM- find time elapsed (current clk - initial clk)...
49060 LATCH$=TIME$:REM latch current time to avoid changes while processing.
49070 H=VAL(MID$(LATCH$,1,2)):M=VAL(MID$(LATCH$,4,2)):S=VAL(MID$(LATCH$,7,2))
49080 CUR=H+(M/60)+(S/3600):REM  current lst hours in decimal
49090 H=VAL(MID$(RUNCLK$,1,2)):M=VAL(MID$(RUNCLK$,4,2)):S=VAL(MID$(RUNCLK$,7,2))
49100 INIT=H+(M/60)+(S/3600):REM  initial lst time when align lst was done.
49110 X=ABS(CUR-INIT):REM absolute value difference
49115 REM get original syst time saved @ align, conv to hrs, add run time (x)
49120 H=VAL(MID$(PCCLK$,1,2)):M=VAL(MID$(PCCLK$,4,2)):S=VAL(MID$(PCCLK$,7,2))
49130 PCCLK=H+(M/60)+(S/3600):REM  initial time when align lst was done.
49140 X=X+PCCLK
49200 GOSUB 38020:REM converts from decimal (checks<>24) & installs new time
49210 RETURN
50000 REM ****** SUBR-- Search for Dob Driver at Parallel Ports ***********
50010 CLS:PRINT"Searching for Dob-Driver at the following addresses...":PRINT
50011 :
50015 OU=888:IN=889:PRINT"0378":REM hex 0378 first.
50017 FOR N=1 TO 20000:OUT OU,FC:NEXT:REM send many times for reluctant xp, sets coarse & provides time for user to read screen.
50020 I=INP(IN):FOR N=1 TO 20000:OUT OU,0:NEXT:REM save busy,send punct char.
50030 IF INP(IN)<>I THEN GOTO 50200:REM busy bit toggled, this address is OK.
50039 :
50040 OU=956:IN=957:PRINT"03BC":FOR N=1 TO 20000:OUT OU,FC:NEXT:REM try 03BC
50050 I=INP(IN):FOR N=1 TO 20000:OUT OU,0:NEXT
50060 IF INP(IN)<>I THEN GOTO 50200:REM busy toggled, this address is OK.
50070 :
50080 OU=64728!:IN=64729!:PRINT"FCD8":FOR N=1 TO 20000:OUT OU,FC:NEXT:REM FCD8
50090 I=INP(IN):FOR N=1 TO 20000:OUT OU,0:NEXT
50100 IF INP(IN)<>I THEN GOTO 50200:REM busy toggled, this address is OK.
50109 :
50110 OU=64744!:IN=64745!:PRINT"FCE8":FOR N=1 TO 20000:OUT OU,FC:NEXT:REM FCE8
50120 I=INP(IN):FOR N=1 TO 20000:OUT OU,0:NEXT
50130 IF INP(IN)<>I THEN GOTO 50200:REM busy toggled, this address is OK.
50139 :
50140 OU=65264!:IN=65265!:PRINT"FEF0":FOR N=1 TO 20000:OUT OU,FC:NEXT:REM FEF0
50150 I=INP(IN):FOR N=1 TO 20000:OUT OU,0:NEXT
50160 IF INP(IN)<>I THEN GOTO 50200:REM busy toggled, this address is OK.
50169 :
50190 FL9=1:REM no dob device connected, set flag
50195 BEEP:PRINT:BEEP:PRINT"No comm-link to Dob-Driver found at above parallel port addresses - hit Enter.":PRINT"Verify hand control is in Pan Mode, and your parallel port is enabled.":INPUT"See Readme files for port config settings/enable/access.",N$
50199 :
50200 RETURN
50210 :
50220 :
59999 :
60000 REM ****************** SPARE AREA **********************
60999 :
61000 REM ****** SAVE LSTTRIM & TRIMSIGN CAL VALUES TO DISK *********
61010 REM- Get from User, then save the variables LSTTRIM & TRIMSIGN in a folder sequentail file for use in 1-sec interrupt adjustment of the LST clock time. All saved as strings.
61020 OPEN "LST_TRIM" FOR OUTPUT AS #1
61030 PRINT#1,STR$(LSTTRIM);",";STR$(TRIMSIGN)
61040 CLOSE #1:RETURN
61499 :
61500 REM ******* GET LSTTRIM & TRIMSIGN CAL VALUES FROM DISK **********
61510 REM- FETCHES LSTTRIM AND TRIMSIGN CAL VALUES FOR USE IN 1-SEC INTERRUPT ADJUSTMENT OF THE LST CLOCK TIME. ALL WERE SAVED AS STRINGS.
61520 OPEN "LST_TRIM" FOR INPUT AS #1
61530 INPUT #1,LSTTRIM$,TRIMSIGN$
61540 CLOSE #1
61550 LSTTRIM=VAL(LSTTRIM$):TRIMSIGN=VAL(TRIMSIGN$)
61560 RETURN
62600 REM ************ CALIBRATE LST CLOCK TRIM VALUES, SAVE ***********
62610 REM- user enters +/- seconds per hour of LST clock time, based on their hand-timer comparison with displayed LST over 1-hour.
62620 REM
62630 CLS
62640 PRINT"LST time correction factor calibration..."
62650 PRINT:PRINT"  This calibration adjusts the RATE of your LST clock (not the actual time). It is computed by Roboscope when you align on stars. It is a rather minor issue for most uses and should only be done by advanced users."
62660 PRINT"  Your LST clock is displayed in the lower-right main screen in Roboscope. That LST clock should gain about 9.8 seconds per hour of run time compared to any    trusted hand timer. But Windows or your PC clock can vary this."
62663 PRINT"  This is normally of no importance unless you are imaging longer than 5 minutes or operating all night, or perhaps over days with the computer on. Then that 10 seconds-per-hour of sidereal sky advancement can become a significant error."
62665 PRINT"  To assess this, start your own external trusted hand-timer when Roboscope     shows an LST at any '00' seconds point, then wait about an hour.
62670 PRINT"  If displayed LST is LESS than 10 seconds AHEAD of your timer after about 1    hour, enter how many secs it lags behind the desired 10 seconds."
62680 PRINT"  If displayed LST is MORE than 10 seconds AHEAD of your timer, enter how many  seconds beyond that it went, but use a minus sign so we can deduct that excess."
62685 PRINT"  This adjustment done here can be done at any time without paying any attention to when you do it, and this action does not alter your present alignment or LST clock or PC clock, nor any other calibrations of Roboscope or Windows itself."
62690 :
62700 PRINT:INPUT"Enter the +/- time offset in seconds-per-hour, a 0 or no-entry will not save or change anything, else will save to disk, make it effective immediately, and will return to main Robo screen: ",TRIM$
62710 IF TRIM$="" THEN RETURN:REM- no user entry, no change, exit.
62715 IF VAL(TRIM$)=0 THEN RETURN:REM- if user enters 0 then no change,exit.
62717 TRIM=VAL(TRIM$):IF ABS(TRIM)>20 THEN CLS:INPUT"Your value is over 20 seconds per hour, not permitted since this may be a sign  of a problem in your clock etc. Hit enter key...",N$:GOTO 62600:REM- inform and go redo.
62720 TRIM=TRIM+(3600/(LSTTRIM*TRIMSIGN)):REM- convert old val in signed secs-per-hr then add to it the change.
62730 TRIMSIGN=1:IF TRIM<0 THEN TRIMSIGN=-1:REM- set the +/- details.
62735 TRIM=ABS(TRIM):REM- now convert to positive if was neg, for countdown use.
62740 IF TRIM<.36 THEN TRIM=.36:REM- cant do infinite, prevent result overfow by forcing a 3600/.36=10000 result (10k secs to a 1-sec adjust, or .36 secs/hr).
62750 LSTTRIM=INT(3600/TRIM):LSTADJ=LSTTRIM:REM- 3600 secs/hr, using integer form for nice clean countdown and display use.
62760 GOSUB 61000:RETURN:REM- save in LST_TRIM file and return.
